#!/bin/bash

set -e

TMP=/tmp/test
SMP=/tmp/scratch
umount $TMP $SMP 2>/dev/null || true
mkdir -p $TMP $SMP

modprobe -r ubifs 2>/dev/null || true
for i in $(seq 0 1)
do
	ubidetach -p /dev/mtd$i 2>/dev/null || true
done
modprobe -r ubi 2>/dev/null || true
modprobe -r nandsim 2>/dev/null || true

mtd=/dev/mtd0
ubi=/dev/ubi0

ARCH=$(uname -m)
if test "$ARCH" == ppc || test "$ARCH" == armv7l
then
	# 512MB, 8-bits, page size 4KB, OOB 128B, block 128KB
	ID="0x20,0xac,0x00,0x16"
	TSIZE=128MiB
	SSIZE=350MiB
else
	# 2GB, 8-bits, page size 4KB, OOB 128B, block 128KB
	ID="0x20,0xa5,0x00,0x16"
	TSIZE=400MiB
	SSIZE=1500MiB
fi
modprobe nandsim id_bytes=$ID
flash_erase -q -j $mtd 0 0
modprobe ubi
modprobe ubifs

ubiattach -p $mtd
ubimkvol $ubi -N test -s $TSIZE
ubimkvol $ubi -N scratch -s $SSIZE

exit 0
